(*********************)
(* methods for TItem *)
(*********************)
{$S ARes}
PROCEDURE TItem.IItem(theCard: TCard; theName: str255; CheckSyntax: Boolean);

	VAR
		theTextHandler: TTextHandler;
		
	BEGIN
		IF CheckSyntax THEN
			SELF.SetTheName(theName)
		ELSE
			fName:= theName;
		fCard:= theCard;
		IF fCard<>NIL THEN
			BEGIN
				theTextHandler:= fCard.GetTextHandler;
				SELF.SetTextHandler(theTextHandler);
			END;
	END;   {TItem.IItem}
	
{$S ARes}
PROCEDURE TItem.StripIllegalChars(VAR theStr: str255);

	VAR
		index: 0..255;
		legalChars: SET OF CHAR;
		done: boolean;

	BEGIN
		legalChars:= ['a'..'z', 'A'..'Z', '0'..'9', '_'];
		index:= 1;
		WHILE index <= Length(theStr) DO
			IF (theStr[index] IN legalChars) THEN
				index:= index + 1
			ELSE
				Delete(theStr, index, 1);
	END;   {TItem.StripIllegalChars}
	
{$S ARes}
PROCEDURE TItem.CapitalizeFirstLetter(VAR theStr: str255);
	VAR
		loCaseChars: SET OF CHAR;
		theLetter: char;
		
	BEGIN
		loCaseChars:= ['a'..'z'];
		theLetter:= theStr[1];
		IF theLetter IN loCaseChars THEN
			BEGIN
				theLetter:= chr(ord(theLetter) - 32);
				theStr[1]:= theLetter;
			END;
	END;   {TItem.CapitalizeFirstLetter}
	
{$S ARes}
FUNCTION TItem.GetTheName: str255;

	BEGIN
		GetTheName:= fName;
	END;   {TItem.GetTheName}
	
{$S ARes}
PROCEDURE TItem.SetTheName(theName: str255);

	BEGIN
		SELF.StripIllegalChars(theName);
		fName:= theName;
		SELF.CheckForPrefix;
	END;   {TItem.SetTheName}
	
{$S ARes}
FUNCTION TItem.GetTheItem: str255;

	BEGIN
		GetTheItem:= SELF.GetTheName;
	END;   {TItem.GetTheItem}
	
{$S ARes}
FUNCTION TItem.GetTheCard: TCard;

	BEGIN
		GetTheCard:= fCard;
	END;	{TItem.GetTheCard}
	
{$S ARes}
PROCEDURE TItem.SetTheCard(theCard: TCard);

	BEGIN
		fCard:=theCard;
	END;	{TItem.GetTheCard}
	
{$S ARes}
FUNCTION TItem.GetTextHandler: TTextHandler;

	BEGIN
		GetTextHandler:= fTextHandler;
	END;   {TItem.GetTheName}
	
{$S ARes}
PROCEDURE TItem.SetTextHandler(theTextHandler: TTextHandler);

	BEGIN
		fTextHandler:= theTextHandler;
	END;   {TItem.SetTextHandler}
	
{$S AWriteFile}
FUNCTION TItem.ReturnBytes: LONGINT;

	BEGIN
		ReturnBytes:= SizeOfCompStr(SELF.GetTheName);
	END;	{TItem.ReturnBytes}
	
{$S AReadFile}
PROCEDURE TItem.ReadTheItem(aRefNum: INTEGER; theCard: TCard; IsOldFile: Boolean);

	VAR
		theString: str255;

	BEGIN
		ReadCompStrFromDisk(aRefNum, theString, IsOldFile);
		SELF.IItem(theCard, theString, IsOldFile);
		{If it's an old file, then 1)it's uncompressed, 2)it must have its syntax checked}
	END;   {TItem.ReadTheItem}
	
{$S AWriteFile}
PROCEDURE TItem.WriteTheItem(aRefNum: INTEGER);

	BEGIN
		WriteCompStrToDisk(aRefNum, SELF.GetTheName);
	END;   {TItem.WriteTheItem}
	
{$S ARes}
PROCEDURE TItem.WriteDeclaration(theTEView: TMyTEView);

	BEGIN
	END;	{TItem.WriteDeclaration}
	
{$S ARes}
PROCEDURE TItem.CheckForPrefix;

	VAR
		currentPrefix,
		nextLetter,
		theName: str255;

	BEGIN
		theName:= fName;
		SELF.CapitalizeFirstLetter(theName);
		currentPrefix:= Copy(theName, 1, 1);
		nextLetter:= Copy(theName, 2, 1);
		IF Length(theName)=0 THEN
 			BEGIN
			END
		ELSE 
			IF ((currentPrefix = kClassPrefix) OR (currentPrefix = kMixinPrefix))
		  		AND (nextLetter >= 'A') AND (nextLetter <= 'Z') THEN  
				{It's prefixed properly if
						1) The first letter is an M or a T AND
						2) the second letter is Capitalized
						OR if it is the null string}
				BEGIN
				END   {so we have to do absolutely nothing}
			ELSE
				BEGIN
					Insert(kClassPrefix,theName,1);  
					{we assume they want a REAL class unless they're specific}
				END;
		fName:= theName;
	END;	{TFieldItem.CheckForPrefix}
	
{$S AFields}
PROCEDURE TItem.Fields(PROCEDURE DoToField(fieldName: Str255; fieldAddr: Ptr; 
		fieldType: INTEGER)); OVERRIDE;
BEGIN
	DoToField('TItem', NIL, bClass);
	DoToField('fName', @fName, bString);
	DoToField('fCard', @fCard, bObject);
	DoToField('fTextHandler', @fTextHandler, bObject);
	INHERITED Fields(DoToField);
END;


(**************************)
(* methods for TFieldItem *)
(**************************)	
{$S ARes}
PROCEDURE TFieldItem.IFieldItem(theCard: TCard; theName, theTypeStr: str255; CheckSyntax: Boolean);

	BEGIN
		SELF.IItem(theCard, theName, CheckSyntax);
		SELF.SetItemType(theTypeStr);
		SELF.MakeGetNIL;
		SELF.MakeSetNIL;
		SELF.SetTheFieldsTypeConst;
		SELF.SetPassByAddress;
	END;	{TFieldItem.IFieldItem}

{$S ARes}
FUNCTION TFieldItem.GetItemType: str255;

	BEGIN
		GetItemType:= fItemType;
	END;   {TFieldItem.GetItemType}
	
{$S ARes}
PROCEDURE TFieldItem.SetItemType(theItemType:str255);

	BEGIN
		SELF.StripIllegalChars(theItemType);
		fItemType:= theItemType;
	END;   {TFieldItem.SetItemType}
	
{$S ARes}
FUNCTION TFieldItem.GetTheItem: str255; OVERRIDE;

	BEGIN
		GetTheItem:= Concat(kFieldPrefix, INHERITED GetTheItem);
	END;	{TFieldItem.GetTheItem}
	
{$S ARes}
FUNCTION TFieldItem.GetTheFieldStr: str255;

	BEGIN
		GetTheFieldStr:= SELF.GetTheItem;
	END;	{TFieldItem.GetTheFieldStr}
	
{$S ARes}
PROCEDURE TFieldItem.SetTheFieldsTypeConst;
	BEGIN
		fFieldsTypeConst:=SELF.GetTextHandler.ReturnFieldsTypeConst(SELF);
	END;	{TFieldItem.SetTheFieldStr}
	
{$S ARes}
PROCEDURE TFieldItem.SetPassByAddress;
	BEGIN
		fPassByAddress:=SELF.GetTextHandler.ReturnByAddress(SELF);
	END;	{TFieldItem.SetPassByAddress}
	
{$S ARes}
FUNCTION TFieldItem.GetPassByAddress: BOOLEAN;
	BEGIN
		GetPassByAddress:=fPassByAddress;
	END;	{TFieldItem.GetPassByAddress}
	
{$S ARes}
FUNCTION TFieldItem.GetTheFieldsTypeConst;
	BEGIN
		GetTheFieldsTypeConst:=fFieldsTypeConst;
	END;	{TFieldItem.SetTheFieldStr}
	
{$S ARes}
PROCEDURE TFieldItem.GetAccessors(VAR theGetter: TGetAccessorItem;
																	VAR theSetter: TSetAccessorItem);

	BEGIN
		theGetter:= fGetAccessor;
		theSetter:= fSetAccessor;
	END;	{TFieldItem.GetAccessors}
	
{$S ARes}
PROCEDURE TFieldItem.SetGetAccessor(theGetter: TGetAccessorItem);

	BEGIN
		fGetAccessor:= theGetter;
	END;	{TFieldItem.SetGetAccessor}
	
{$S ARes}
PROCEDURE TFieldItem.SetSetAccessor(theSetter: TSetAccessorItem);

	BEGIN
		fSetAccessor:= theSetter;
	END;	{TFieldItem.SetSetAccessor}
	
{$S ARes}
PROCEDURE TFieldItem.MakeGetNIL;

	BEGIN
		fGetAccessor:= NIL;
	END;	{TFieldItem.MakeGetNIL}
	
{$S ARes}
PROCEDURE TFieldItem.MakeSetNIL;

	BEGIN
		fSetAccessor:= NIL;
	END;	{TFieldItem.MakeGetNIL.}
	
{$S ARes}
FUNCTION TFieldItem.GetTheDeclaration: str255;

	VAR
		theDeclarationStr: str255;

	BEGIN
		GetTheDeclaration:=fTextHandler.GetFieldItemDeclaration(SELF);
	END;	{TFieldItem.GetTheDeclaration}
	
{$S ARes}
FUNCTION TFieldItem.GetTheImplDeclaration: str255;

	VAR
		theDeclarationStr: str255;

	BEGIN
		GetTheImplDeclaration:=fTextHandler.GetFieldItemImplDeclaration(SELF);
	END;	{TFieldItem.GetTheImplDeclaration}
	
{$S ARes}
PROCEDURE TFieldItem.WriteDeclaration(theTEView: TMyTEView); OVERRIDE;

	VAR
		theDeclarationStr: str255;

	BEGIN
		theDeclarationStr:=SELF.GetTheDeclaration;
		fTextHandler.Replace(theDeclarationStr, '^VOID', 'void');
		theTEView.WriteToMyTEView(theDeclarationStr);
		theTEView.WriteEndOfLine;
	END;	{TFieldItem.WriteDeclaration}
	
{$S ARes}
PROCEDURE TFieldItem.CheckForPrefix; OVERRIDE;

	VAR
		currentPrefix,
		theName: str255;

	BEGIN
		theName:= fName;
		IF Length(theName)>0 THEN  
			{make sure there's something there to work with}
			BEGIN
				currentPrefix:= Copy(theName, 1, 1);
				IF (currentPrefix = kFieldPrefix) THEN
					Delete(theName, 1, 1);
				SELF.CapitalizeFirstLetter(theName);
				fName:= theName;
			END;
	END;	{TFieldItem.CheckForPrefix}
		
{$S AWriteFile}
FUNCTION TFieldItem.ReturnBytes: LONGINT; OVERRIDE;

	BEGIN
		ReturnBytes:= SizeOfCompStr(SELF.GetTheName) + 
			SizeOfCompStr(SELF.GetItemType) + 2 * SIZEOF(LONGINT) ;
	END;	{TFieldItem.ReturnBytes}

{$S AReadFile}
PROCEDURE TFieldItem.ReadTheItem(aRefNum: INTEGER; theCard: TCard;
																IsOldFile: Boolean); OVERRIDE;

	VAR
		theName,
		theType: str255;
		itemSize, GetAccessorNumber, SetAccessorNumber: LONGINT;
		theGetAccessor: TGetAccessorItem;
		theSetAccessor: TSetAccessorItem;
		theMethod: TMethodItem;

	PROCEDURE ShallowCopyMethod(theMethodItem: TMethodItem; theAccessor:TAccessorItem);
		BEGIN
			theAccessor.IAccessorItem(theMethodItem.GetTheCard, theMethodItem.GetTheName,
														SELF, IsOldFile);
			theAccessor.SetOVERRIDE(theMethodItem.GetOVERRIDE); {if they're really twisted, they
																													can override the override}
		END;

	BEGIN
		ReadCompStrFromDisk(aRefNum, theName, IsOldFile);
		ReadCompStrFromDisk(aRefNum, theType, IsOldFile);
		SELF.IFieldItem(theCard, theName, theType, IsOldFile);
		{If it's an old file, then 1)it's uncompressed, 2)it must have its syntax checked}

		itemSize:= SIZEOF(GetAccessorNumber);
		FailOSErr(FSRead(aRefNum, itemSize,@GetAccessorNumber));
		IF GetAccessorNumber<>0 THEN
			BEGIN
				theMethod:= theCard.GetMethodItemAtIndex(GetAccessorNumber);
				NEW(theGetAccessor);
				FailNil(theGetAccessor);
				ShallowCopyMethod(theMethod, theGetAccessor);
				SELF.SetGetAccessor(theGetAccessor);
				theCard.DeleteMethod(theMethod);
				theCard.AddMethodAtIndex(theGetAccessor,GetAccessorNumber);
				theMethod.Free;
			END;
		FailOSErr(FSRead(aRefNum, itemSize,@SetAccessorNumber));
		IF SetAccessorNumber<>0 THEN
			BEGIN
				theMethod:= theCard.GetMethodItemAtIndex(SetAccessorNumber);
				NEW(theSetAccessor);
				FailNil(theSetAccessor);
				ShallowCopyMethod(theMethod, theSetAccessor);
				SELF.SetSetAccessor(theSetAccessor);
				theCard.DeleteMethod(theMethod);
				theCard.AddMethodAtIndex(theSetAccessor, SetAccessorNumber);
				theMethod.Free;
			END;
	END;	{TFieldItem.ReadTheItem}

{$S AWriteFile}
PROCEDURE TFieldItem.WriteTheItem(aRefNum: INTEGER); OVERRIDE;

	VAR
		itemSize, itemLoc: LONGINT;
		theGetAccessor: TGetAccessorItem;
		theSetAccessor: TSetAccessorItem;

	BEGIN
		WriteCompStrToDisk(aRefNum, SELF.GetTheName);
		WriteCompStrToDisk(aRefNum, SELF.GetItemType);
		itemSize:= SIZEOF(LONGINT);
		SELF.GetAccessors(theGetAccessor,theSetAccessor);
		itemLoc:= SELF.GetTheCard.GetIndexOfMethod(theGetAccessor);
		FailOSErr(FSWrite(aRefNum, itemSize, @itemLoc));
		itemLoc:= SELF.GetTheCard.GetIndexOfMethod(theSetAccessor);
		FailOSErr(FSWrite(aRefNum, itemSize, @itemLoc));
	END;	{TFieldItem.WriteTheItem}
	
{$S AFields}
PROCEDURE TFieldItem.Fields(PROCEDURE DoToField(fieldName: Str255; fieldAddr: Ptr; 
		fieldType: INTEGER)); OVERRIDE;

	BEGIN
		DoToField('TFieldItem', NIL, bClass);
		DoToField('fItemType', @fItemType, bString);
		DoToField('fGetAccessor', @fGetAccessor, bObject);
		DoToField('fSetAccessor', @fSetAccessor, bObject);
		DoToField('fFieldsTypeConst', @fFieldsTypeConst, bString);
		DoToField('fPassByAddress', @fPassByAddress, bBoolean);
		INHERITED Fields(DoToField);
	END;   {TFieldItem.Fields}


(***************************)
(* methods for TMethodItem *)
(***************************)
{$S ARes}
FUNCTION TMethodItem.GetOVERRIDE: boolean;

	BEGIN
		GetOVERRIDE:= fOVERRIDE;
	END;	{TMethodItem.GetOVERRIDE}
	
{$S ARes}
PROCEDURE TMethodItem.SetOVERRIDE(overrideIt: boolean);

	BEGIN
		fOVERRIDE:= overrideIt;
	END;	{TMethodItem.GetOVERRIDE}
	
{$S ARes}
PROCEDURE TMethodItem.IMethodItem(theCard: TCard; theName: str255;
																	makeItOVERRIDE, CheckSyntax: boolean);

	BEGIN
		SELF.SetOVERRIDE(makeItOVERRIDE);
		SELF.IItem(theCard, theName, CheckSyntax);
	END;	{TMethodItem.IMethodItem}
	
{$S AWriteFile}
FUNCTION TMethodItem.ReturnBytes: LONGINT; OVERRIDE;

	BEGIN
		ReturnBytes:= SizeOfCompStr(SELF.GetTheName) + SIZEOF(boolean);
	END;	{TMethodItem.ReturnBytes}

{$S ARes}
FUNCTION TMethodItem.GetNumRealMethods: integer;

	BEGIN
		GetNumRealMethods:= 1;	{count me, I'm real.}
	END;	{TMethodItem.GetNumRealMethods}
	
{$S AReadFile}
PROCEDURE TMethodItem.ReadTheItem(aRefNum: INTEGER; theCard: TCard;
																IsOldFile: Boolean); OVERRIDE;

	VAR
		theString: str255;
		isOVERRIDE: boolean;
		itemSize: LONGINT;

	BEGIN
		ReadCompStrFromDisk(aRefNum, theString, IsOldFile);
		itemSize:=  SIZEOF(boolean);
		FailOSErr(FSRead(aRefNum, ItemSize, @isOVERRIDE));
		SELF.IMethodItem(theCard, theString, isOVERRIDE, IsOldFile);
		{If it's an old file, then 1)it's uncompressed, 2)it must have its syntax checked}
	END;   {TMethodItem.ReadTheItem}
	
{$S AWriteFile}
PROCEDURE TMethodItem.WriteTheItem(aRefNum: INTEGER); OVERRIDE;

	VAR
		itemSize: LONGINT;
		isOVERRIDE: boolean;

	BEGIN
		WriteCompStrToDisk(aRefNum, SELF.GetTheName);
		itemSize:= SIZEOF(boolean);
		isOVERRIDE:= SELF.GetOVERRIDE;
		FailOSErr(FSWrite(aRefNum, itemSize, @isOVERRIDE));
	END;   {TMethodItem.WriteTheItem}

{$S ARes}
FUNCTION TMethodItem.GetTheCodeLine: str255;
BEGIN
	GetTheCodeLine:='Big ERROR';
END;
	
{$S ARes}
PROCEDURE TMethodItem.WriteDeclaration(theTEView: TMyTEView); OVERRIDE;

	VAR
		theDeclarationStr: str255;

	BEGIN
		theDeclarationStr:=SELF.GetTheDeclaration;
		theTEView.WriteToMyTEView(theDeclarationStr);
	END;	{TMethodItem.WriteDeclaration}

{$S ARes}
PROCEDURE TMethodItem.CheckForPrefix; OVERRIDE;

	VAR
		theName: str255;

	BEGIN
		theName:= fName;
		SELF.CapitalizeFirstLetter(theName);
		fName:= theName;
		{DO NOTHING ELSE: let the names of the methods be whatever the user wants}
	END;	{TMethodItem.CheckForPrefix}
	
{$S ARes}
FUNCTION TMethodItem.GetTheDeclaration: str255;

	VAR
		theClass: TItem;
		theClassName: str255;

	BEGIN
		theClass:= fCard.GetTheClass;
		theClassName:= theClass.GetTheItem;
		IF fOVERRIDE THEN
			GetTheDeclaration:= fTextHandler.GetOverrideMethStr(SELF)
		ELSE
			GetTheDeclaration:= fTextHandler.GetStdMethStr(SELF);
	END;	{TMethodItem.GetTheDeclaration}
	
{$S ARes}
FUNCTION TMethodItem.GetTheImplDeclaration: str255;

	VAR
		theClass: TItem;
		theClassName: str255;

	BEGIN
		theClass:= fCard.GetTheClass;
		theClassName:= theClass.GetTheItem;
		IF fOVERRIDE THEN
			GetTheImplDeclaration:= fTextHandler.GetOverrideImplMethStr(SELF)
		ELSE
			GetTheImplDeclaration:= fTextHandler.GetStdImplMethStr(SELF);
	END;	{TMethodItem.GetTheImplDeclaration}

{$S ARes}
PROCEDURE TMethodItem.WriteInlineProcedures(theTEView: TMyTEView);
BEGIN				{NOTE:Normal methods have no Inline definitions}
END;

{$S ARes}
PROCEDURE TMethodItem.WriteImplementation(theTEView: TMyTEView);

	BEGIN
		theTEView.WriteToMyTEView(fTextHandler.GetStdMethodImplementationStr(SELF));
	END;	{TMethodItem.WriteImplementation}

{$S ARes}
PROCEDURE TMethodItem.StripIllegalChars(VAR theStr: str255); OVERRIDE;

	VAR
		numbers: SET OF CHAR;
		theCard: TCard;
		theTextHandler: TTextHandler;
		IsDestructor: Boolean;

	BEGIN
		IsDestructor:=FALSE;
		IF theStr[1] = '~' THEN
			BEGIN
				theCard:= SELF.GetTheCard;
				theTextHandler:= theCard.GetTextHandler;
				IF theTextHandler.GetLanguage = kInCPP THEN
					BEGIN
						IsDestructor:=TRUE;
						Delete(theStr,1,1);  {remove the destructor symbol}
					END;
			END;
		INHERITED StripIllegalChars(theStr);
		numbers:= ['0'..'9'];
		WHILE (theStr[1] IN numbers) AND (Length(theStr)>0) DO
			Delete(theStr,1,1);
		IF IsDestructor THEN 
			begin
				Insert('~',theStr,1);  {add it back in if it was there}
			end;
	END;   {TMethodItem.StripIllegalChars}	

{$S ARes}
FUNCTION TMethodItem.GetSegment: str255;
BEGIN
  GetSegment:='ARes';
END;

{$S AFields}
PROCEDURE TMethodItem.Fields(PROCEDURE DoToField(fieldName: Str255; fieldAddr: Ptr; 
		fieldType: INTEGER)); OVERRIDE;

	BEGIN
		DoToField('TMethodItem', NIL, bClass);
		DoToField('fOVERRIDE', @fOVERRIDE, bBoolean);
		INHERITED Fields(DoToField);
	END;   {TMethodItem.Fields}

(*********************************)
(* methods for TFieldsMethodItem *)
(*********************************)
	
{$S ARes}
FUNCTION TFieldsMethodItem.GetTheDeclaration: str255; OVERRIDE;

	BEGIN
		GetTheDeclaration:= fTextHandler.GetFieldsMethodDecStr(SELF);
	END;	{TFieldsMethodItem.GetTheDeclaration}
	
{$S ARes}
FUNCTION TFieldsMethodItem.GetTheImplDeclaration: str255; OVERRIDE;

	BEGIN
		GetTheImplDeclaration:= fTextHandler.GetImplFieldsMethodDecStr(SELF);
	END;	{TFieldsMethodItem.GetTheImplDeclaration}
	
{$S ARes}
PROCEDURE TFieldsMethodItem.WriteImplementation(theTEView: TMyTEView); OVERRIDE;

	VAR
		aList: TMyList;
		
	PROCEDURE WriteTheLine(theFieldItem: TFieldItem);
	
		VAR
			theCodeLine: str255;
	
		BEGIN
			theTEView.WriteToMyTEView(fTextHandler.GetFieldsMethodCodeLineStr(TheFieldItem));
		END;	{WriteTheLine}

	BEGIN
		theTEView.WriteToMyTEView(fTextHandler.GetFieldsMethodImpStr1(SELF));
		theTEView.WriteToMyTEView(SELF.GetTheImplDeclaration);
		theTEView.WriteToMyTEView(fTextHandler.GetFieldsMethodImpStr2(SELF));
		
		aList:= fCard.GetFields;
		aList.Each(WriteTheLine);
		aList:= fCard.GetCollaborators;
		aList.Each(WriteTheLine);
		
		theTEView.WriteToMyTEView(fTextHandler.GetFieldsMethodImpStr3);
	END;	{TFieldsMethodItem.WriteImplementation}
	
{$S ARes}
FUNCTION TFieldsMethodItem.GetNumRealMethods: integer; OVERRIDE;

	BEGIN
		GetNumRealMethods:= 0;	{don't count me, I'm not real.}
	END;	{TFieldsMethodItem.GetNumRealMethods}
	
{$S ARes}
FUNCTION TFieldsMethodItem.ReturnBytes: LONGINT; OVERRIDE;

	BEGIN
		ReturnBytes:= 0;
	END;	{TFieldsMethodItem.ReturnBytes}
	
{$S ARes}
PROCEDURE TFieldsMethodItem.ReadTheItem(aRefNum: INTEGER; theCard: TCard;
																IsOldFile: Boolean); OVERRIDE;

	BEGIN
		{do nothing}
	END;	{TFieldsMethodItem.ReadTheItem}
	
{$S ARes}
PROCEDURE TFieldsMethodItem.WriteTheItem(aRefNum: INTEGER); OVERRIDE;

	BEGIN
		{do nothing}
	END;	{TFieldsMethodItem.WriteTheItem}

{$S ARes}
FUNCTION TFieldsMethodItem.GetSegment: str255;
BEGIN
  GetSegment:='AFields';
END;	{TFieldsMethodItem.GetSegment}

{$S ARes}
FUNCTION TFieldsMethodItem.GetTheItem: str255; OVERRIDE;
BEGIN
  GetTheItem:='Fields';
END;	{TFieldsMethodItem.GetTheItem}

FUNCTION TFieldsMethodItem.GetOVERRIDE: boolean; OVERRIDE;
{$S ARes}
BEGIN
  GetOVERRIDE:=TRUE;
END;	{TFieldsMethodItem.GetOVERRIDE}

(*****************************)
(* methods for TAccessorItem *)
(*****************************)
{$S ARes}
PROCEDURE TAccessorItem.IAccessorItem(theCard: TCard; theName: str255; 
																			ourField: TFieldItem; CheckSyntax: Boolean);
										
	BEGIN
		SELF.IMethodItem(theCard, theName, NOT kOVERRIDE, CheckSyntax);
		SELF.SetFieldReference(ourField);
	END;	{TAccessorItem.IAccessorItem}
	
{$S ARes}
PROCEDURE TAccessorItem.SetFieldReference(theField: TFieldItem);
	
	BEGIN
		fFieldAccessed:= theField;
	END;	{TAccessorItem.SetFieldReference}
	
{$S ARes}
FUNCTION TAccessorItem.GetFieldAccessed: TFieldItem;

	BEGIN
		GetFieldAccessed:=fFieldAccessed;
	END; {TAccessorItem.GetFieldAccessed}
	
{$S ARes}
PROCEDURE TAccessorItem.SetFunction(makeItAFunction: boolean);
	
	BEGIN
		fFunction:= makeItAFunction;
	END;	{TAccessorItem.}
	
{$S ARes}
FUNCTION TAccessorItem.GetTheDeclaration: str255; OVERRIDE;
	
	BEGIN
		ProgramBreak('ERROR in TACCESSORITEM.GETTHEDECLARATION');
	END;	{TAccessorItem.GetTheDeclaration}
	
{$S ARes}
FUNCTION TAccessorItem.GetTheImplDeclaration: str255; OVERRIDE;
	
	BEGIN
		ProgramBreak('ERROR in TACCESSORITEM.GETTHEimplDECLARATION');
	END;	{TAccessorItem.GetTheImplDeclaration}
	
{$S ARes}
FUNCTION TAccessorItem.GetParameter: str255;

	BEGIN
		GetParameter:= Concat('the', SELF.GetTheName);
	END;	{TAccessorItem.GetParameter}

{$S ARes}
PROCEDURE TAccessorItem.WriteImplementation(theTEView: TMyTEView); OVERRIDE;

	BEGIN
		theTEView.WriteToMyTEView(SELF.GetTheCodeLine);
	END;	{TAccessorItem.WriteImplementation}
		
{$S AFields}
PROCEDURE TAccessorItem.Fields(PROCEDURE DoToField(fieldName: Str255; fieldAddr: Ptr; 
		fieldType: INTEGER)); OVERRIDE;

	BEGIN
		DoToField('TAccessorItem', NIL, bClass);
		DoToField('fFunction', @fFunction, bBoolean);
		DoToField('fFieldAccessed', @fFieldAccessed, bObject);
		INHERITED Fields(DoToField);
	END;   {TMethodItem.Fields}
 

(********************************)
(* methods for TGetAccessorItem *)
(********************************)
{$S ARes}
FUNCTION TGetAccessorItem.GetTheCodeLine: str255; OVERRIDE;
BEGIN
		GetTheCodeLine:=fTextHandler.GetGetAccessorImplementation(SELF);
END; {TGetAccessorItem.GetTheCodeLine}

{$S ARes}
FUNCTION TGetAccessorItem.GetTheItem: str255; OVERRIDE;
	
	BEGIN
		GetTheItem:= Concat(kGetAccessorPrefix, INHERITED GetTheItem);
	END;	{TGetAccessorItem.GetTheItem}

{$S ARes}
FUNCTION TGetAccessorItem.GetTheDeclaration: str255; OVERRIDE;
	
	BEGIN
		GetTheDeclaration:= fTextHandler.GetGetAccessorStr(SELF)
	END;	{TGetAccessorItem.GetTheDeclaration}
	
{$S ARes}
FUNCTION TGetAccessorItem.GetTheImplDeclaration: str255; OVERRIDE;
	
	BEGIN
		GetTheImplDeclaration:= fTextHandler.GetImplGetAccessorStr(SELF);
	END;	{TGetAccessorItem.GetTheImplDeclaration}
	
{$S ARes}
PROCEDURE TGetAccessorItem.WriteInlineProcedures(theTEView: TMyTEView); OVERRIDE;

BEGIN	
	theTEView.WriteToMyTEView(fTextHandler.GetInlineGetAccessorStr(SELF));
END;

{$S ARes}
PROCEDURE TGetAccessorItem.CheckForPrefix; OVERRIDE;

VAR
	currentPrefix,
	theName: Str255;
	prefixLength: Integer;
	
BEGIN
	theName:= fName;
	IF Length(theName)>0 THEN
		BEGIN
			SELF.CapitalizeFirstLetter(theName);
			prefixLength:=length(kGetAccessorPrefix);
			if length(theName)>prefixLength THEN
				BEGIN
					currentPrefix:=Copy(theName, 1, prefixLength);
					IF (currentPrefix = kGetAccessorPrefix) THEN
						Delete(theName, 1, prefixLength);
				END;
			fName:=theName;
		END;
END; {TGetAccessorItem.CheckForPrefix}
	
{$S AClose}
PROCEDURE TGetAccessorItem.Free; OVERRIDE;
	
	BEGIN
		fFieldAccessed.MakeGetNIL;
		INHERITED Free;
	END;	{TGetAccessorItem.Free}


(***********************************)
(* methods for TSetAccessorItem *)
(***********************************)
{$S ARes}
FUNCTION TSetAccessorItem.GetTheCodeLine: str255; OVERRIDE;
BEGIN
	GetTheCodeLine:=fTextHandler.GetSetAccessorImplementation(SELF);
END; {TSetAccessorItem.GetTheCodeLine}
	
{$S ARes}
FUNCTION TSetAccessorItem.GetTheItem: str255; OVERRIDE;
	
	BEGIN
		GetTheItem:= Concat(kSetAccessorPrefix, INHERITED GetTheItem);
	END;	{TSetAccessorItem.GetTheItem}

{$S ARes}
FUNCTION TSetAccessorItem.GetTheDeclaration: str255; OVERRIDE;
	
	BEGIN
		GetTheDeclaration:= fTextHandler.GetSetAccessorStr(SELF);
	END;	{TSetAccessorItem.GetTheDeclaration}
	
{$S ARes}
FUNCTION TSetAccessorItem.GetTheImplDeclaration: str255; OVERRIDE;
	
	BEGIN
		GetTheImplDeclaration:= fTextHandler.GetImplSetAccessorStr(SELF);
	END;	{TSetAccessorItem.GetTheImplDeclaration}
	
{$S ARes}
PROCEDURE TSetAccessorItem.WriteInlineProcedures(theTEView: TMyTEView); OVERRIDE;

	BEGIN				
		theTEView.WriteToMyTEView(fTextHandler.GetInlineSetAccessorStr(SELF));
	END;

{$S ARes}
PROCEDURE TSetAccessorItem.CheckForPrefix; OVERRIDE;

VAR
	currentPrefix,
	theName: Str255;
	prefixLength: Integer;
	
BEGIN
	theName:= fName;
	IF Length(theName)>0 THEN
		BEGIN
			SELF.CapitalizeFirstLetter(theName);
			prefixLength:=length(kSetAccessorPrefix);
			if length(theName)>prefixLength THEN
				BEGIN
					currentPrefix:=Copy(theName, 1, prefixLength);
					IF (currentPrefix = kSetAccessorPrefix) THEN
						Delete(theName, 1, prefixLength);
				END;
			fName:=theName;
		END;
END; {TSetAccessorItem.CheckForPrefix}

{$S AClose}
PROCEDURE TSetAccessorItem.Free; OVERRIDE;
	
	BEGIN
		fFieldAccessed.MakeSetNIL;
		INHERITED Free;
	END;	{TSetAccessorItem.Free}


(***********************************)
(* methods for TCollaboratorItem *)
(***********************************)
{$S ARes}
PROCEDURE TCollaboratorItem.ICollaboratorItem(theCard: TCard; theName: str255;
																							CheckSyntax: Boolean);

	VAR
		ourTypeStr: str255;
		
	BEGIN
		SELF.IFieldItem(theCard, theName, kEmptyString, CheckSyntax);
		ourTypeStr:= SELF.GetTheItem;
		SELF.SetItemType(ourTypeStr);
	END;	{TCollaboratorItem.ICollaboratorItem}
	
{$S ARes}
PROCEDURE TCollaboratorItem.CheckForPrefix; OVERRIDE;

	VAR
		currentPrefix,
		nextLetter,
		theName: str255;

	BEGIN
		theName:= fName;
		IF Length(theName)>0 THEN  {leave it alone if it's blank!!}
			BEGIN
				SELF.CapitalizeFirstLetter(theName);
				currentPrefix:= Copy(theName, 1, 1);
				IF (currentPrefix = kClassPrefix) AND (Length(theName)>1) THEN
					BEGIN
						nextLetter:= Copy(theName, 2, 1);
						IF (nextLetter >= 'A') AND (nextLetter <= 'Z') THEN
							Delete(theName, 1, 1);
					END;
				fName:= theName;
			END;
	END;	{TCollaboratorItem.CheckForPrefix}
	
{$S ARes}
FUNCTION TCollaboratorItem.GetTheItem: str255; OVERRIDE;

	BEGIN
		GetTheItem:= Concat(kClassPrefix, SELF.fName);
	END;	{TCollaboratorItem.GetTheItem}
	
{$S ARes}
FUNCTION TCollaboratorItem.GetTheFieldStr: str255;

	BEGIN
		GetTheFieldStr:= Concat(kFieldPrefix, SELF.fName);
	END;	{TCollaboratorItem.GetTheFieldStr}
	
{$S ARes}
PROCEDURE TCollaboratorItem.SetTheFieldsTypeConst; OVERRIDE;

	BEGIN
		fFieldsTypeConst:= 'bObject';
	END;	{TCollaboratorItem.SetTheFieldsTypeConst}
	
{$S ARes}
FUNCTION TCollaboratorItem.GetTheDeclaration: str255; OVERRIDE;

	BEGIN
		GetTheDeclaration:= fTextHandler.GetCollaboratorDeclaration(SELF);
	END;	{TCollaboratorItem.GetTheDeclaration}
	
{$S ARes}
FUNCTION TCollaboratorItem.GetTheImplDeclaration: str255; OVERRIDE;

	BEGIN
		GetTheImplDeclaration:= fTextHandler.GetImplCollaboratorDeclaration(SELF);
	END;	{TCollaboratorItem.GetTheImplDeclaration}
	
{$S AWriteFile}
FUNCTION TCollaboratorItem.ReturnBytes: LONGINT; OVERRIDE;

	BEGIN
		ReturnBytes:= SizeOfCompStr(SELF.GetTheName) +  2 * SIZEOF(LONGINT) ;
	END;	{TCollaboratorItem.ReturnBytes}

{$S AReadFile}
PROCEDURE TCollaboratorItem.ReadTheItem(aRefNum: INTEGER; theCard: TCard;
																IsOldFile: Boolean); OVERRIDE;

	VAR
		theName,
		theType: str255;
		itemSize, GetAccessorNumber, SetAccessorNumber: LONGINT;
		theGetAccessor: TGetAccessorItem;
		theSetAccessor: TSetAccessorItem;
		theMethod: TMethodItem;

	PROCEDURE ShallowCopyMethod(theMethodItem: TMethodItem; theAccessor:TAccessorItem);
		BEGIN
			theAccessor.IAccessorItem(theMethodItem.GetTheCard, theMethodItem.GetTheName,
																SELF, IsOldFile);
			theAccessor.SetOVERRIDE(theMethodItem.GetOVERRIDE); {if they're really twisted, they
																													can override the override}
		END;

	BEGIN
		ReadCompStrFromDisk(aRefNum, theName, IsOldFile);
		SELF.ICollaboratorItem(theCard, theName, IsOldFile);
		{If it's an old file, then 1)it's uncompressed, 2)it must have its syntax checked}

		itemSize:= SIZEOF(GetAccessorNumber);
		FailOSErr(FSRead(aRefNum, itemSize,@GetAccessorNumber));
		IF GetAccessorNumber<>0 THEN
			BEGIN
				theMethod:= theCard.GetMethodItemAtIndex(GetAccessorNumber);
				NEW(theGetAccessor);
				FailNil(theGetAccessor);
				ShallowCopyMethod(theMethod, theGetAccessor);
				SELF.SetGetAccessor(theGetAccessor);
				theCard.DeleteMethod(theMethod);
				theCard.AddMethodAtIndex(theGetAccessor,GetAccessorNumber);
				theMethod.Free;
			END;
		FailOSErr(FSRead(aRefNum, itemSize,@SetAccessorNumber));
		IF SetAccessorNumber<>0 THEN
			BEGIN
				theMethod:= theCard.GetMethodItemAtIndex(SetAccessorNumber);
				NEW(theSetAccessor);
				FailNil(theSetAccessor);
				ShallowCopyMethod(theMethod, theSetAccessor);
				SELF.SetSetAccessor(theSetAccessor);
				theCard.DeleteMethod(theMethod);
				theCard.AddMethodAtIndex(theSetAccessor, SetAccessorNumber);
				theMethod.Free;
			END;
	END;	{TCollaboratorItem.ReadTheItem}

{$S AWriteFile}
PROCEDURE TCollaboratorItem.WriteTheItem(aRefNum: INTEGER); OVERRIDE;

	VAR
		itemSize, itemLoc: LONGINT;
		theString: str255;
		theGetAccessor: TGetAccessorItem;
		theSetAccessor: TSetAccessorItem;

	BEGIN
		WriteCompStrToDisk(aRefNum, SELF.GetTheName);
		itemSize:= SIZEOF(LONGINT);
		SELF.GetAccessors(theGetAccessor,theSetAccessor);
		itemLoc:= SELF.GetTheCard.GetIndexOfMethod(theGetAccessor);
		FailOSErr(FSWrite(aRefNum, itemSize, @itemLoc));
		itemLoc:= SELF.GetTheCard.GetIndexOfMethod(theSetAccessor);
		FailOSErr(FSWrite(aRefNum, itemSize, @itemLoc));
	END;   {TCollaboratorItem.WriteTheItem}
